import serial, time
from math import floor

WIDTH=600
HEIGHT=420
GREY=(195,195,195)

ser = serial.Serial('/dev/ttyS0', baudrate = 115200, timeout=5)

pico_img = Actor('pico_adcs')
pico_img.topleft = 10,10

pin_img_disabled = "pin-disabled"
pin_img_enabled = "pin-enabled"

pin_imgs = [
    Actor(pin_img_enabled, (300, 210)),
    Actor(pin_img_disabled, (300, 190)),
    Actor(pin_img_disabled, (300, 155)),
    ]

selected_pin = 0
voltage = 0


def draw ():
    screen.clear()
    screen.fill((GREY))
    pico_img.draw()
    for this_pin in pin_imgs :
        this_pin.draw()
    screen.draw.text("RasPi/PICO", centery=20, centerx=400, fontsize=50, color="#000080")
    screen.draw.text("Multi-channel", centery=60, centerx=400, fontsize=50, color="#000080")
    screen.draw.text("System", centery=100, centerx=400, fontsize=60, color="#000080")
    screen.draw.text("ADC"+str(selected_pin)+":", topleft=(300,250), fontsize=50, color="#000080")
    screen.draw.text(str(voltage), topleft=(300,300), fontsize=100, color="#000080")
    screen.draw.text("V", topleft=(450,300), fontsize=100, color="#000080")


def update ():
    global voltage
    ser.write((selected_pin+48).to_bytes(1, byteorder='little'))
    input=ser.read_until()
    sub_input=input.decode("utf-8").split()
    if (str(sub_input[1])==str(selected_pin)):
        voltage=round(float(sub_input[3]),2)
    print (str(sub_input))

def on_mouse_down(pos, button):
    global selected_pin
    if button == mouse.LEFT:
        for pin_id in range (0,len(pin_imgs)) :
            if pin_imgs[pin_id].collidepoint(pos):
                pin_imgs[selected_pin].image = pin_img_disabled
                selected_pin = pin_id
                pin_imgs[selected_pin].image = pin_img_enabled